#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <vector>
#include <algorithm>
#include <utility>
using namespace std;
#define null NULL
#define mp make_pair
#define pb(a) push_back(a)
#define sz(a) ((int)(a).size())
#define all(a) a.begin() , a.end()
#define fi first
#define se second
#define relaxMin(a , b) (a) = min((a),(b))
#define relaxMax(a , b) (a) = max((a),(b))
#define SQR(a) ((a)*(a))
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef long long ll;
// Random
static unsigned long w=521288629;
#define wnew (w=18000*(w&65535)+(w>>16))
// </end>
#define MAX 310
#define NONE 1000000000
// Input
int N , M;
int id[MAX][MAX];
ll cost[MAX][MAX] , go[MAX][MAX];
vector<pii> E;

FILE* input;

int MAX_LEN = 2;
vi GFO[MAX];
void prepare_GFO(){
  for(int i=0;i<sz(E);++i)
   GFO[E[i].fi].pb(E[i].se),
   GFO[E[i].se].pb(E[i].fi);
}
bool compare_deg(const int& f , const int& s){
  return sz(GFO[f]) > sz(GFO[s]);
}

void read(){
  fscanf(input , "%d%d" , &N , &M);
  for(int i=0;i<N;++i)
   for(int j=0;j<N;++j) cost[i][j] = NONE;
  for(int i=0;i<M;++i){
   int f , t , pr;
   fscanf(input , "%d%d%d" , &f , &t , &pr);
   --f , --t;
   id[f][t] = id[t][f] = i+1;
   cost[f][t] = cost[t][f] = pr;
   relaxMax(MAX_LEN , pr);
   E.pb(mp(f , t));
                      }
  for(int i=0 , val;i<N;++i)
   for(int j=0;j<N;++j)
    fscanf(input , "%d" , &val),
    go[i][j] = val;
}
// Tree representation
int fo[MAX][MAX] , szfo[MAX];
void clear_tree(){
  for(int i=0;i<N;++i) szfo[i] = 0;
}
void add_edge(int f , int t){
  fo[f][szfo[f]++] = t;
  fo[t][szfo[t]++] = f;
}
void rem_edge(int f , int t){
  int pos = find(fo[f] , fo[f] + szfo[f] , t) - fo[f];
  for(int i=pos+1;i<szfo[f];++i) fo[f][i-1] = fo[f][i];
  --szfo[f];
  pos = find(fo[t] , fo[t] + szfo[t] , f) - fo[t];
  for(int i=pos+1;i<szfo[t];++i) fo[t][i-1] = fo[t][i];
  --szfo[t];
}
// Cost evaluation
ll COST;
int base;
ll DIST[MAX][MAX];
void init_cost(int vr , int par = -1 , ll len = 0){
  if(base < vr)
   COST += len * go[base][vr],
   DIST[base][vr] = DIST[vr][base] = len;
  for(int i=0,tmp;i<szfo[vr];++i)
   if((tmp = fo[vr][i]) != par)
    init_cost(tmp , vr , len + cost[vr][tmp]);
}
void evaluate(){
  COST = 0;
  for(int i=0;i<N;++i) init_cost(base = i);
}
// Random solution
int uf_par[MAX];
int get_par(int vr){
  return uf_par[vr] == vr ? vr : uf_par[vr] = get_par(uf_par[vr]);
}
bool merge(int a , int b){
  a = get_par(a) , b = get_par(b);
  if(a == b)return false;
  uf_par[a] = b;
  return true;
}
int RANDOM_TREE_STEP = 0;
void random_tree(){
  ++RANDOM_TREE_STEP;
  if(MAX_LEN == 2 && RANDOM_TREE_STEP <= 2){
   clear_tree();
   for(int i=0;i<N;++i)
    uf_par[i] = i;
   vi ver;
   for(int i=0;i<N;++i) ver.pb(i);
   sort(all(ver) , compare_deg);
   for(int i=0;i<sz(ver);++i){
    int vr = ver[i];
    for(int j=0;j<sz(GFO[vr]);++j)
     if(merge(vr , GFO[vr][j]))
      add_edge(vr , GFO[vr][j]);
                             }
                                           }
  else{
   random_shuffle(all(E));
   clear_tree();
   for(int i=0;i<N;++i)
    uf_par[i] = i;
   for(int i=0;i<sz(E);++i)
    if(merge(E[i].fi , E[i].se))
     add_edge(E[i].fi , E[i].se);
      }
}
// Modifying solution
ll path_len[MAX] , NCOST;
int LE[MAX] , SLE , RE[MAX] , SRE;
int *BUF , SBUF;
void init_paths(int vr , int par = -1 , ll len = 0){
  path_len[vr] = len;
  BUF[SBUF++] = vr;
  for(int i=0,tmp;i<szfo[vr];++i)
   if((tmp = fo[vr][i]) != par)
    init_paths(tmp , vr , len + cost[vr][tmp]);
}
ll going[MAX] , traffic , price[MAX];
void check_time();
// init of price to get
ll CUR_PRICE , ALL_GOING;
ll subtree_going[MAX];
ll init_going(int vr , int par = -1){
  subtree_going[vr] = going[vr];
  for(int i=0,tmp;i<szfo[vr];++i)
   if((tmp = fo[vr][i]) != par)
    subtree_going[vr] += init_going(tmp , vr);
  return subtree_going[vr];
}
void dfs_price(int vr , int par = -1){
  price[vr] = CUR_PRICE;
  for(int i=0,tmp;i<szfo[vr];++i)
   if((tmp = fo[vr][i]) != par){
    ll delta = (ALL_GOING - (subtree_going[tmp]<<1))
               * cost[vr][tmp];
    CUR_PRICE += delta;
    dfs_price(tmp , vr);
    CUR_PRICE -= delta;
                               }
}
void init_price(int* SIDE , int SZ){
  CUR_PRICE = 0;
  ll* dst = DIST[SIDE[0]];
  for(int j=0;j<SZ;++j)
   CUR_PRICE += going[SIDE[j]] * dst[SIDE[j]];
  init_going(SIDE[0]);
  ALL_GOING = subtree_going[SIDE[0]];
  dfs_price(SIDE[0]);
}
// </end>
void random_update(int f , int t){
  check_time();
  rem_edge(f , t);
  BUF = LE , SBUF = 0;
  init_paths(f) , SLE = SBUF;
  BUF = RE , SBUF = 0;
  init_paths(t) , SRE = SBUF;
  random_shuffle(LE , LE+SLE);
  random_shuffle(RE , RE+SRE);
  traffic = 0;
  memset(going , 0 , N*sizeof(ll));
  memset(price , 0 , N*sizeof(ll));
  int le , ri;
  for(int i=0;i<SLE;++i){
   le = LE[i];
   for(int j=0;j<SRE;++j){
    ri = RE[j];
    traffic += go[le][ri];
    going[le] += go[le][ri];
    going[ri] += go[le][ri];
                         }
                        }
  init_price(LE , SLE);
  init_price(RE , SRE);
  COST -= price[f] + price[t] + traffic*cost[f][t];
  ll MIN = -1;
  int nf , nt;
  for(int i=0;i<SLE;++i){
   le = LE[i];
   for(int j=0;j<SRE;++j){
    ri = RE[j];
    if(cost[le][ri] == NONE)continue;
    ll ccost = price[le] + price[ri] + traffic*cost[le][ri];
    if(MIN==-1 || MIN>ccost || (MIN == ccost && (wnew&1)))
     MIN = ccost,
     nf = le , nt = ri;
                         }
                        }
  COST += MIN;
  add_edge(nf , nt);
  for(int i=0;i<SLE;++i){
   le = LE[i];
   for(int j=0;j<SRE;++j){
    ri = RE[j];
    DIST[ri][le] = DIST[le][ri] = DIST[le][nf] + cost[nf][nt] +
                                  DIST[nt][ri];
                         }
                        }
}
// Best answer
ll best_COST = -12345;
int best_fo[MAX][MAX] , best_szfo[MAX];
void copy(){
  memcpy(best_szfo , szfo , N*sizeof(int));
  for(int i=0;i<N;++i)
   memcpy(best_fo[i] , fo[i] , best_szfo[i]*sizeof(int));
  best_COST = COST;
}
void update(){
  if(best_COST == -12345 || best_COST > COST)
   copy();
}
// Verificator
bool verify(){
  memcpy(szfo , best_szfo , N*sizeof(int));
  for(int i=0;i<N;++i)
   memcpy(fo[i] , best_fo[i] , best_szfo[i]*sizeof(int));
  evaluate();
  return COST == best_COST;
}
// Output
void write(){
  for(int i=0;i<N;++i)
   for(int j=0;j<best_szfo[i];++j)
    if(i < best_fo[i][j])printf("%d\n" , id[i][best_fo[i][j]]);
}
// Optimization
double my_random(){
  return (rand()+0.0) / RAND_MAX;
}
#define TIME_LIMIT 1.9
void check_time(){
  if((clock()-0.0) / CLOCKS_PER_SEC > TIME_LIMIT){
   update();
   write();
   //cout<<best_COST<<endl;
   //cout<<(verify() ? "OK\n" : "BAD\n");
   exit(0);
                                                 }
}
void doit(){
  random_tree();
  evaluate();
  check_time();
  vector<pii> E;
  while(true){
   E.clear();
   for(int i=0;i<N;++i)
    for(int j=0;j<szfo[i];++j)
     if(i < fo[i][j]) E.pb(mp(i , fo[i][j]));
   random_shuffle(all(E));
   ll old = COST;
   for(int i=0;i<sz(E);++i)
    random_update(E[i].fi , E[i].se);
   if(old <= COST)break;
             }
  update();
}
int main(){
  srand(13);
  input = fopen("graph.in" , "r");
  //input = stdin;
  freopen("graph.out" , "w" , stdout);
  read() , fclose(input);
  if(MAX_LEN == 2) prepare_GFO();
  for(;;)doit();
  return 0;
}
